/* user_interface.h

   These are all the functions that the user interface must implement
   and export. Different user interface are free to implement them
   differently, even as stub functions, but they must all be there.

   This file is included from calc.h and from [xt]siag.h.
*/

/*extern Window xwindow_of_window(window *);*/

extern void interp_startup(void);
extern int select_file(char *, char *, char **, char *);
extern int alert_box(char *, char **, int);
extern int select_from_list(char *, char **, int);
extern void error_box(char *);

/* Postscript */
extern char *ps_fontname(int);
extern int ps_text_width(int, char *);
extern int ps_font_descent(int);
extern int ps_font_height(long);
extern int ps_embed_print(FILE *, char *, int, int);
extern int ps_font_size(int);

/* from input.c (now window.h) */
extern int ask_for_str_comp(char *, char *, int (*)(char *));
extern int ask_for_str(char *, char *);
extern int edit_cell(char *, char *);
extern int macro_flag;
extern textbuf kbd_macro;

/* plugin functions */
extern int siag_plugin_start(char *);
extern int siag_plugin_stop(int);
extern int siag_plugin_save(int, char *);
extern int siag_plugin_hide(int);
extern int siag_plugin_print(int, FILE *);
extern int siag_plugin_size_get(int, unsigned long *, unsigned long *);

